OGRE: Ogre::Material Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Material Class Referencefinal
Core » Materials

Class encapsulates rendering properties of an object. More...

`#include <OgreMaterial.h>`

Inheritance diagram for Ogre::Material:
[legend]

## Public Types
typedef ConstVectorIterator< LodValueList > | LodValueIterator
typedef std::vector< Real > | LodValueList
| distance list used to specify LOD
typedef VectorIterator< Techniques > | TechniqueIterator
typedef std::vector< Technique * > | Techniques
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions
| Material (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor - use resource manager's create method rather than this.
| ~Material ()
void | _notifyNeedsRecompile (void)
| Tells the material that it needs recompilation.
MaterialPtr | clone (const String &newName, bool changeGroup, const String &newGroup=BLANKSTRING) const
MaterialPtr | clone (const String &newName, const char *newGroup) const
MaterialPtr | clone (const String &newName, const String &newGroup=BLANKSTRING) const
| Creates a new copy of this material with the same settings but a new name.
void | compile (bool autoManageTextureUnits=true)
| 'Compiles' this Material.
void | copyDetailsTo (MaterialPtr &mat) const
| Copies the details of this material into another, preserving the target's handle and name (unlike operator=) but copying everything else.
bool | getCompilationRequired () const
| Gets the compilation status of the material.
bool | getReceiveShadows (void) const
| Returns whether or not objects using this material will receive shadows.
bool | getTransparencyCastsShadows (void) const
| Returns whether or not objects using this material be classified as opaque to the shadow caster system.
bool | isTransparent (void) const
| Determines if the material has any transparency with the rest of the scene (derived from whether any Techniques say they involve transparency).
Material & | operator= (const Material &rhs)
| Assignment operator to allow easy copying between materials.
void | setReceiveShadows (bool enabled)
| Sets whether objects using this material will receive shadows.
void | setTransparencyCastsShadows (bool enabled)
| Sets whether objects using this material be classified as opaque to the shadow caster system.
void | touch (void) override
| 'Touches' the resource to indicate it has been used.
Techniques
Technique * | createTechnique (void)
| Creates a new Technique for this Material.
Technique * | getTechnique (size_t index) const
| Gets the indexed technique.
Technique * | getTechnique (const String &name) const
| searches for the named technique.
size_t | getNumTechniques (void) const
| Retrieves the number of techniques.
void | removeTechnique (unsigned short index)
| Removes the technique at the given index.
void | removeAllTechniques (void)
| Removes all the techniques in this Material.
TechniqueIterator | getTechniqueIterator (void)
| Get an iterator over the Techniques in this Material.
const Techniques & | getTechniques (void) const
| Get the Techniques in this Material.
const Techniques & | getSupportedTechniques (void) const
| Gets all the Techniques which are supported by the current card.
TechniqueIterator | getSupportedTechniqueIterator (void)
Technique * | getSupportedTechnique (size_t index) const
| Gets the indexed supported technique.
size_t | getNumSupportedTechniques (void) const
| Retrieves the number of supported techniques.
const String & | getUnsupportedTechniquesExplanation () const
| Gets a string explaining why any techniques are not supported.
Technique * | getBestTechnique (unsigned short lodIndex=0, const Renderable *rend=0)
| Gets the best supported technique.
Forwarded Pass Properties
The following methods are to make migration from previous versions simpler and to make code easier to write when dealing with simple materials They set the properties which have been moved to Pass for all Techniques and all Passes
void | setPointSize (Real ps)
| Sets the point size properties for every Pass in every Technique.
void | setAmbient (float red, float green, float blue)
| Sets the ambient colour reflectance properties for every Pass in every Technique.
void | setAmbient (const ColourValue &ambient)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setDiffuse (float red, float green, float blue, float alpha)
| Sets the diffuse colour reflectance properties of every Pass in every Technique.
void | setDiffuse (const ColourValue &diffuse)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setSpecular (float red, float green, float blue, float alpha)
| Sets the specular colour reflectance properties of every Pass in every Technique.
void | setSpecular (const ColourValue &specular)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setShininess (Real val)
| Sets the shininess properties of every Pass in every Technique.
void | setSelfIllumination (float red, float green, float blue)
| Sets the amount of self-illumination of every Pass in every Technique.
void | setSelfIllumination (const ColourValue &selfIllum)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setDepthCheckEnabled (bool enabled)
| Sets whether or not each Pass renders with depth-buffer checking on or not.
void | setDepthWriteEnabled (bool enabled)
| Sets whether or not each Pass renders with depth-buffer writing on or not.
void | setDepthFunction (CompareFunction func)
| Sets the function used to compare depth values when depth checking is on.
void | setColourWriteEnabled (bool enabled)
| Sets whether or not colour buffer writing is enabled for each Pass.
void | setColourWriteEnabled (bool red, bool green, bool blue, bool alpha)
| Sets which colour buffer channels are enabled for writing for each Pass.
void | setCullingMode (CullingMode mode)
| Sets the culling mode for each pass based on the 'vertex winding'.
void | setManualCullingMode (ManualCullingMode mode)
| Sets the manual culling mode, performed by CPU rather than hardware.
void | setLightingEnabled (bool enabled)
| Sets whether or not dynamic lighting is enabled for every Pass.
void | setShadingMode (ShadeOptions mode)
| Sets the type of light shading required.
void | setFog (bool overrideScene, FogMode mode=FOG_NONE, const ColourValue &colour=ColourValue::White, Real expDensity=0.001f, Real linearStart=0.0f, Real linearEnd=1.0f)
| Sets the fogging mode applied to each pass.
void | setDepthBias (float constantBias, float slopeScaleBias)
| Sets the depth bias to be used for each Pass.
void | setTextureFiltering (TextureFilterOptions filterType)
| Set texture filtering for every texture unit in every Technique and Pass.
void | setTextureAnisotropy (int maxAniso)
| Sets the anisotropy level to be used for all textures.
void | setSceneBlending (const SceneBlendType sbt)
| Sets the kind of blending every pass has with the existing contents of the scene.
void | setSeparateSceneBlending (const SceneBlendType sbt, const SceneBlendType sbta)
| Sets the kind of blending every pass has with the existing contents of the scene, using individual factors for color and alpha channels.
void | setSceneBlending (const SceneBlendFactor sourceFactor, const SceneBlendFactor destFactor)
| Allows very fine control of blending every Pass with the existing contents of the scene.
void | setSeparateSceneBlending (const SceneBlendFactor sourceFactor, const SceneBlendFactor destFactor, const SceneBlendFactor sourceFactorAlpha, const SceneBlendFactor destFactorAlpha)
| Allows very fine control of blending every Pass with the existing contents of the scene, using individual factors for color and alpha channels.
Level of Detail
unsigned short | getNumLodLevels (unsigned short schemeIndex) const
| Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.
unsigned short | getNumLodLevels (const String &schemeName) const
| Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.
void | setLodLevels (const LodValueList &lodValues)
| Sets the distance at which level-of-detail (LOD) levels come into effect.
const LodValueList & | getLodValues (void) const
| Gets the list of values transformed by the LodStrategy at which each LOD comes into effect.
LodValueIterator | getLodValueIterator (void) const
const LodValueList & | getUserLodValues (void) const
| Gets the user-defined list of values which are internally transformed by the LodStrategy.
LodValueIterator | getUserLodValueIterator (void) const
ushort | getLodIndex (Real value) const
| Gets the LOD index to use at the given value.
const LodStrategy * | getLodStrategy () const
| Get LOD strategy used by this material.
void | setLodStrategy (LodStrategy *lodStrategy)
| Set the LOD strategy used by this material.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Detailed Description

Class encapsulates rendering properties of an object.

Ogre's material class encapsulates all aspects of the visual appearance, of an object. It also includes other flags which might not be traditionally thought of as material properties such as culling modes and depth buffer settings, but these affect the appearance of the rendered object and are convenient to attach to the material since it keeps all the settings in one place. This is different to Direct3D which treats a material as just the colour components (diffuse, specular) and not texture maps etc. An Ogre Material can be thought of as equivalent to a 'Shader'.

A Material can be rendered in multiple different ways depending on the hardware available. You may configure a Material to use high-complexity fragment shaders, but these won't work on every card; therefore a Technique is an approach to creating the visual effect you are looking for. You are advised to create fallback techniques with lower hardware requirements if you decide to use advanced features. In addition, you also might want lower-detail techniques for distant geometry.

Each Technique can be made up of multiple passes. A fixed-function Pass may combine multiple texture layers using multitexturing, but Ogre can break that into multiple passes automatically if the active card cannot handle that many simultaneous textures. Programmable passes, however, cannot be split down automatically, so if the active graphics card cannot handle the technique which contains these passes, OGRE will try to find another technique which the card can do. If, at the end of the day, the card cannot handle any of the techniques which are listed for the material, the engine will render the geometry plain white, which should alert you to the problem.

Ogre comes configured with a number of default settings for a newly created material. These can be changed if you wish by retrieving the default material settings through MaterialManager::getDefaultSettings. Any changes you make to the Material returned from this method will apply to any materials created from this point onward.

## Member Typedef Documentation

## ◆ LodValueList

typedef std::vector<Real> Ogre::Material::LodValueList

distance list used to specify LOD

## ◆ LodValueIterator

typedef ConstVectorIterator<LodValueList> Ogre::Material::LodValueIterator

## ◆ Techniques

typedef std::vector<Technique*> Ogre::Material::Techniques

## ◆ TechniqueIterator

typedef VectorIterator<Techniques> Ogre::Material::TechniqueIterator

## Constructor & Destructor Documentation

## ◆ Material()

Ogre::Material::Material | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Constructor - use resource manager's create method rather than this.

Referenced by operator=().

## ◆ ~Material()

Ogre::Material::~Material | ( |  | ) |

## Member Function Documentation

## ◆ operator=()

Material & Ogre::Material::operator= | ( | const Material & | rhs | ) |

Assignment operator to allow easy copying between materials.

References Material().

## ◆ isTransparent()

bool Ogre::Material::isTransparent | ( | void |  | ) | const

Determines if the material has any transparency with the rest of the scene (derived from whether any Techniques say they involve transparency).

## ◆ setReceiveShadows()

void Ogre::Material::setReceiveShadows | ( | bool | enabled | ) |
| inline

Sets whether objects using this material will receive shadows.

This method allows a material to opt out of receiving shadows, if it would otherwise do so. Shadows will not be cast on any objects unless the scene is set up to support shadows (

See also
  SceneManager::setShadowTechnique), and not all techniques cast shadows on all objects. In any case, if you have a need to prevent shadows being received by material, this is the method you call to do it.

Note
  Transparent materials never receive shadows despite this setting. The default is to receive shadows.

## ◆ getReceiveShadows()

bool Ogre::Material::getReceiveShadows | ( | void |  | ) | const
| inline

Returns whether or not objects using this material will receive shadows.

## ◆ setTransparencyCastsShadows()

void Ogre::Material::setTransparencyCastsShadows | ( | bool | enabled | ) |
| inline

Sets whether objects using this material be classified as opaque to the shadow caster system.

This method allows a material to cast a shadow, even if it is transparent. By default, transparent materials neither cast nor receive shadows. Shadows will not be cast on any objects unless the scene is set up to support shadows (

See also
  SceneManager::setShadowTechnique), and not all techniques cast shadows on all objects.

## ◆ getTransparencyCastsShadows()

bool Ogre::Material::getTransparencyCastsShadows | ( | void |  | ) | const
| inline

Returns whether or not objects using this material be classified as opaque to the shadow caster system.

## ◆ createTechnique()

Technique * Ogre::Material::createTechnique | ( | void |  | ) |

Creates a new Technique for this Material.

A Technique is a single way of rendering geometry in order to achieve the effect you are intending in a material. There are many reason why you would want more than one - the main one being to handle variable graphics card abilities; you might have one technique which is impressive but only runs on 4th-generation graphics cards, for example. In this case you will want to create at least one fallback Technique. OGRE will work out which Techniques a card can support and pick the best one.

  If multiple Techniques are available, the order in which they are created is important - the engine will consider lower-indexed Techniques to be preferable to higher-indexed Techniques, ie when asked for the 'best' technique it will return the first one in the technique list which is supported by the hardware.

## ◆ getTechnique() [1/2]

Technique * Ogre::Material::getTechnique | ( | size_t | index | ) | const
| inline

Gets the indexed technique.

## ◆ getTechnique() [2/2]

Technique * Ogre::Material::getTechnique | ( | const String & | name | ) | const

searches for the named technique.

Return 0 if technique with name is not found

## ◆ getNumTechniques()

size_t Ogre::Material::getNumTechniques | ( | void |  | ) | const
| inline

Retrieves the number of techniques.

## ◆ removeTechnique()

void Ogre::Material::removeTechnique | ( | unsigned short | index | ) |

Removes the technique at the given index.

## ◆ removeAllTechniques()

void Ogre::Material::removeAllTechniques | ( | void |  | ) |

Removes all the techniques in this Material.

## ◆ getTechniqueIterator()

TechniqueIterator Ogre::Material::getTechniqueIterator | ( | void |  | ) |

Get an iterator over the Techniques in this Material.

Deprecated
  use getTechniques()

## ◆ getTechniques()

const Techniques & Ogre::Material::getTechniques | ( | void |  | ) | const
| inline

Get the Techniques in this Material.

## ◆ getSupportedTechniques()

const Techniques & Ogre::Material::getSupportedTechniques | ( | void |  | ) | const
| inline

Gets all the Techniques which are supported by the current card.

The supported technique list is only available after this material has been compiled, which typically happens on loading the material. Therefore, if this method returns an empty list, try calling Material::load.

## ◆ getSupportedTechniqueIterator()

TechniqueIterator Ogre::Material::getSupportedTechniqueIterator | ( | void |  | ) |

Deprecated
  use getSupportedTechniques()

## ◆ getSupportedTechnique()

Technique * Ogre::Material::getSupportedTechnique | ( | size_t | index | ) | const
| inline

Gets the indexed supported technique.

## ◆ getNumSupportedTechniques()

size_t Ogre::Material::getNumSupportedTechniques | ( | void |  | ) | const
| inline

Retrieves the number of supported techniques.

## ◆ getUnsupportedTechniquesExplanation()

const String & Ogre::Material::getUnsupportedTechniquesExplanation | ( |  | ) | const
| inline

Gets a string explaining why any techniques are not supported.

## ◆ getBestTechnique()

Technique * Ogre::Material::getBestTechnique | ( | unsigned short | lodIndex = 0,
|  | const Renderable * | rend = 0 )

Gets the best supported technique.

This method returns the lowest-index supported Technique in this material (since lower-indexed Techniques are considered to be better than higher-indexed ones).

  The best supported technique is only available after this material has been compiled, which typically happens on loading the material. Therefore, if this method returns NULL, try calling Material::load.

Parameters

  lodIndex | The material LOD index to use
  rend | Optional parameter specifying the Renderable that is requesting this technique. Only used if no valid technique for the active material scheme is found, at which point it is passed to MaterialManager::Listener::handleSchemeNotFound as information.

## ◆ clone() [1/3]

MaterialPtr Ogre::Material::clone | ( | const String & | newName,
|  | const String & | newGroup = BLANKSTRING ) const

Creates a new copy of this material with the same settings but a new name.

Parameters

  newName | The name for the cloned material
  newGroup | Optional name of the new group to assign the clone to; if you leave this blank, the clone will be assigned to the same group as this Material.

References Ogre::BLANKSTRING.

Referenced by clone().

## ◆ clone() [2/3]

MaterialPtr Ogre::Material::clone | ( | const String & | newName,
|  | const char * | newGroup ) const
| inline

References clone().

Referenced by clone().

## ◆ clone() [3/3]

MaterialPtr Ogre::Material::clone | ( | const String & | newName,
|  | bool | changeGroup,
|  | const String & | newGroup = BLANKSTRING ) const
| inline

Deprecated
  use clone(const String&, const String&)

References Ogre::BLANKSTRING, and clone().

## ◆ copyDetailsTo()

void Ogre::Material::copyDetailsTo | ( | MaterialPtr & | mat | ) | const

Copies the details of this material into another, preserving the target's handle and name (unlike operator=) but copying everything else.

Parameters

  mat | Weak reference to material which will receive this material's settings.

## ◆ compile()

void Ogre::Material::compile | ( | bool | autoManageTextureUnits = true | ) |

'Compiles' this Material.

Compiling a material involves determining which Techniques are supported on the card on which OGRE is currently running, and for fixed-function Passes within those Techniques, splitting the passes down where they contain more TextureUnitState instances than the current card has texture units.

  This process is automatically done when the Material is loaded, but may be repeated if you make some procedural changes.

Parameters

  autoManageTextureUnits | If true, when a fixed function pass has too many TextureUnitState entries than the card has texture units, the Pass in question will be split into more than one Pass in order to emulate the Pass. If you set this to false and this situation arises, an Exception will be thrown.

Referenced by touch().

## ◆ setPointSize()

void Ogre::Material::setPointSize | ( | Real | ps | ) |

Sets the point size properties for every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setPointSize

## ◆ setAmbient() [1/2]

void Ogre::Material::setAmbient | ( | float | red,
|  | float | green,
|  | float | blue )

Sets the ambient colour reflectance properties for every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setAmbient

## ◆ setAmbient() [2/2]

void Ogre::Material::setAmbient | ( | const ColourValue & | ambient | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ setDiffuse() [1/2]

void Ogre::Material::setDiffuse | ( | float | red,
|  | float | green,
|  | float | blue,
|  | float | alpha )

Sets the diffuse colour reflectance properties of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setDiffuse

## ◆ setDiffuse() [2/2]

void Ogre::Material::setDiffuse | ( | const ColourValue & | diffuse | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ setSpecular() [1/2]

void Ogre::Material::setSpecular | ( | float | red,
|  | float | green,
|  | float | blue,
|  | float | alpha )

Sets the specular colour reflectance properties of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSpecular

## ◆ setSpecular() [2/2]

void Ogre::Material::setSpecular | ( | const ColourValue & | specular | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ setShininess()

void Ogre::Material::setShininess | ( | Real | val | ) |

Sets the shininess properties of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setShininess

## ◆ setSelfIllumination() [1/2]

void Ogre::Material::setSelfIllumination | ( | float | red,
|  | float | green,
|  | float | blue )

Sets the amount of self-illumination of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSelfIllumination

## ◆ setSelfIllumination() [2/2]

void Ogre::Material::setSelfIllumination | ( | const ColourValue & | selfIllum | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ setDepthCheckEnabled()

void Ogre::Material::setDepthCheckEnabled | ( | bool | enabled | ) |

Sets whether or not each Pass renders with depth-buffer checking on or not.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setDepthCheckEnabled

## ◆ setDepthWriteEnabled()

void Ogre::Material::setDepthWriteEnabled | ( | bool | enabled | ) |

Sets whether or not each Pass renders with depth-buffer writing on or not.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setDepthWriteEnabled

## ◆ setDepthFunction()

void Ogre::Material::setDepthFunction | ( | CompareFunction | func | ) |

Sets the function used to compare depth values when depth checking is on.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setDepthFunction

## ◆ setColourWriteEnabled() [1/2]

void Ogre::Material::setColourWriteEnabled | ( | bool | enabled | ) |

Sets whether or not colour buffer writing is enabled for each Pass.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setColourWriteEnabled

## ◆ setColourWriteEnabled() [2/2]

void Ogre::Material::setColourWriteEnabled | ( | bool | red,
|  | bool | green,
|  | bool | blue,
|  | bool | alpha )

Sets which colour buffer channels are enabled for writing for each Pass.

See also
  Pass::setColourWriteEnabled

## ◆ setCullingMode()

void Ogre::Material::setCullingMode | ( | CullingMode | mode | ) |

Sets the culling mode for each pass based on the 'vertex winding'.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setCullingMode

## ◆ setManualCullingMode()

void Ogre::Material::setManualCullingMode | ( | ManualCullingMode | mode | ) |

Sets the manual culling mode, performed by CPU rather than hardware.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setManualCullingMode

## ◆ setLightingEnabled()

void Ogre::Material::setLightingEnabled | ( | bool | enabled | ) |

Sets whether or not dynamic lighting is enabled for every Pass.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setLightingEnabled

## ◆ setShadingMode()

void Ogre::Material::setShadingMode | ( | ShadeOptions | mode | ) |

Sets the type of light shading required.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setShadingMode

## ◆ setFog()

void Ogre::Material::setFog | ( | bool | overrideScene,
|  | FogMode | mode = FOG_NONE,
|  | const ColourValue & | colour = ColourValue::White,
|  | Real | expDensity = 0.001f,
|  | Real | linearStart = 0.0f,
|  | Real | linearEnd = 1.0f )

Sets the fogging mode applied to each pass.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setFog

References Ogre::FOG_NONE, and Ogre::ColourValue::White.

## ◆ setDepthBias()

void Ogre::Material::setDepthBias | ( | float | constantBias,
|  | float | slopeScaleBias )

Sets the depth bias to be used for each Pass.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setDepthBias

## ◆ setTextureFiltering()

void Ogre::Material::setTextureFiltering | ( | TextureFilterOptions | filterType | ) |

Set texture filtering for every texture unit in every Technique and Pass.

Note
  This property has been moved to the TextureUnitState class, which is accessible via the Technique and Pass. For simplicity, this method allows you to set these properties for every current TeextureUnitState, If you need more precision, retrieve the Technique, Pass and TextureUnitState instances and set the property there.

See also
  TextureUnitState::setTextureFiltering

## ◆ setTextureAnisotropy()

void Ogre::Material::setTextureAnisotropy | ( | int | maxAniso | ) |

Sets the anisotropy level to be used for all textures.

Note
  This property has been moved to the TextureUnitState class, which is accessible via the Technique and Pass. For simplicity, this method allows you to set these properties for every current TeextureUnitState, If you need more precision, retrieve the Technique, Pass and TextureUnitState instances and set the property there.

See also
  TextureUnitState::setTextureAnisotropy

## ◆ setSceneBlending() [1/2]

void Ogre::Material::setSceneBlending | ( | const SceneBlendType | sbt | ) |

Sets the kind of blending every pass has with the existing contents of the scene.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSceneBlending

## ◆ setSeparateSceneBlending() [1/2]

void Ogre::Material::setSeparateSceneBlending | ( | const SceneBlendType | sbt,
|  | const SceneBlendType | sbta )

Sets the kind of blending every pass has with the existing contents of the scene, using individual factors for color and alpha channels.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSeparateSceneBlending

## ◆ setSceneBlending() [2/2]

void Ogre::Material::setSceneBlending | ( | const SceneBlendFactor | sourceFactor,
|  | const SceneBlendFactor | destFactor )

Allows very fine control of blending every Pass with the existing contents of the scene.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSceneBlending

## ◆ setSeparateSceneBlending() [2/2]

void Ogre::Material::setSeparateSceneBlending | ( | const SceneBlendFactor | sourceFactor,
|  | const SceneBlendFactor | destFactor,
|  | const SceneBlendFactor | sourceFactorAlpha,
|  | const SceneBlendFactor | destFactorAlpha )

Allows very fine control of blending every Pass with the existing contents of the scene, using individual factors for color and alpha channels.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSeparateSceneBlending

## ◆ _notifyNeedsRecompile()

void Ogre::Material::_notifyNeedsRecompile | ( | void |  | ) |

Tells the material that it needs recompilation.

## ◆ getNumLodLevels() [1/2]

unsigned short Ogre::Material::getNumLodLevels | ( | unsigned short | schemeIndex | ) | const

Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.

Note that this will not be up to date until the material has been compiled.

## ◆ getNumLodLevels() [2/2]

unsigned short Ogre::Material::getNumLodLevels | ( | const String & | schemeName | ) | const

Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.

Note that this will not be up to date until the material has been compiled.

## ◆ setLodLevels()

void Ogre::Material::setLodLevels | ( | const LodValueList & | lodValues | ) |

Sets the distance at which level-of-detail (LOD) levels come into effect.

You should only use this if you have assigned LOD indexes to the Technique instances attached to this Material. If you have done so, you should call this method to determine the distance at which the lowe levels of detail kick in. The decision about what distance is actually used is a combination of this and the LOD bias applied to both the current Camera and the current Entity.

Parameters

  lodValues | A vector of Reals which indicate the LOD value at which to switch to lower details. They are listed in LOD index order, starting at index 1 (ie the first level down from the highest level 0, which automatically applies from a value of 0). These are 'user values', before being potentially transformed by the strategy, so for the distance strategy this is an unsquared distance for example.

## ◆ getLodValues()

const LodValueList & Ogre::Material::getLodValues | ( | void |  | ) | const
| inline

Gets the list of values transformed by the LodStrategy at which each LOD comes into effect.

Note that the iterator returned from this method is not totally analogous to the one passed in by calling setLodLevels - the list includes a zero entry at the start (since the highest LOD starts at value 0). Also, the values returned are after being transformed by LodStrategy::transformUserValue.

## ◆ getLodValueIterator()

LodValueIterator Ogre::Material::getLodValueIterator | ( | void |  | ) | const

Deprecated
  use getLodValues()

## ◆ getUserLodValues()

const LodValueList & Ogre::Material::getUserLodValues | ( | void |  | ) | const
| inline

Gets the user-defined list of values which are internally transformed by the LodStrategy.

Note that the iterator returned from this method is not totally analogous to the one passed in by calling setLodLevels - the list includes a zero entry at the start (since the highest LOD starts at value 0). Also, the values returned are after being transformed by LodStrategy::transformUserValue.

## ◆ getUserLodValueIterator()

LodValueIterator Ogre::Material::getUserLodValueIterator | ( | void |  | ) | const

Deprecated
  use getUserLodValues()

## ◆ getLodIndex()

ushort Ogre::Material::getLodIndex | ( | Real | value | ) | const

Gets the LOD index to use at the given value.

Note
  The value passed in is the 'transformed' value. If you are dealing with an original source value (e.g. distance), use LodStrategy::transformUserValue to turn this into a lookup value.

## ◆ getLodStrategy()

const LodStrategy * Ogre::Material::getLodStrategy | ( |  | ) | const

Get LOD strategy used by this material.

## ◆ setLodStrategy()

void Ogre::Material::setLodStrategy | ( | LodStrategy * | lodStrategy | ) |

Set the LOD strategy used by this material.

## ◆ touch()

void Ogre::Material::touch | ( | void |  | ) |
| inlineoverridevirtual

'Touches' the resource to indicate it has been used.

Reimplemented from Ogre::Resource.

References compile(), and Ogre::Resource::touch().

## ◆ getCompilationRequired()

bool Ogre::Material::getCompilationRequired | ( |  | ) | const
| inline

Gets the compilation status of the material.

Returns
  True if the material needs recompilation.

The documentation for this class was generated from the following file:

- OgreMaterial.h